Base class for those classes that can appear inside the build file as stand alone data types.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

package | phing.tasks.ext
author | Andreas Aderhold
author | Hans Lellelid
version | $Id$

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()

## getOutfile()

    getOutfile()

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()

### Returns

`\Project`Reference to current porject object

## getType()

    getType()

## getUseFile()

    getUseFile()

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()

## Validate config.

    parsingComplete() : void

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()

### Parameters

#### $desc

## setOutfile()

    setOutfile($outfile)

### Parameters

#### $outfile

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

inherited_from | \DataType::setRefid()

### Parameters

#### $r

`\Reference`

## setType()

    setType($type)

### Parameters

#### $type

## setUseFile()

    setUseFile($useFile)

### Parameters

#### $useFile

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked

##

    $outfile : string

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project

##

    $type : string

##

    $useFile : bool